#include "led.h"
#include <Arduino.h>

#include "pin.h"

long lastBlink = 0;

bool ledGState = false;
bool ledRState = false;
bool ledBState = false;

namespace Led{
  void init(){
    pinMode(Pin::LED_R, OUTPUT);
    pinMode(Pin::LED_G, OUTPUT);
    pinMode(Pin::LED_B, OUTPUT);

    digitalWrite(Pin::LED_R, LOW);
    digitalWrite(Pin::LED_G, LOW);
    digitalWrite(Pin::LED_B, LOW);
  }

  void ledR(bool state){
    if(ledRState != state){
      digitalWrite(Pin::LED_R, state);
      ledRState = state;
    }
  }

  void ledG(bool state){
    if(ledGState != state){
      digitalWrite(Pin::LED_G, state);
      ledGState = state;
    }
  }

  void ledB(bool state){
    if(ledBState != state){
      digitalWrite(Pin::LED_B, state);
      ledBState = state;
    }
  }

  void test(){
    ledR(true);
    delay(1000);
    ledG(true);
    delay(1000);
    ledB(true);
    delay(2000);
    ledR(false);
    delay(1000);
    ledG(false);
    delay(1000);
    ledB(false);  
  }

  void blink(){
    if(!ledGState){
      if(millis() - lastBlink > 2000){
        ledG(true);
        lastBlink = millis();
      }
    }else{
      if(millis() - lastBlink > 80){
        ledG(false);
        lastBlink = millis();
      }
    }
  }
}